/* LICENSE BLOCK
Part of mde: a Modular D game-oriented Engine
Copyright © 2007-2008 Diggory Hardy

This program is free software; you can redistribute it and/or modify it under the terms of
the GNU General Public License, version 2, as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. */

/** A module to run all mde unittests and potentially to perform other tests.
*/
module test.mdeTest;

// This module should import all mde modules containing unittests:
import mde.input.input;
import mde.mergetag.DataSet;
import mde.mergetag.mtunittest;
import mde.exception;
import mde.Init;
import mde.i18n.I18nTranslation;

import tango.util.log.Log : Log, Logger;

// Set this version to tell mde.init that the root logger is set up here.
version=mdeTest;

private Logger logger;

static this()
{
    // Set up console logging:
    Logger root = Log.getRootLogger();
    root.setLevel(root.Level.Trace);
    root.addAppender(new ConsoleAppender);
    
    logger = Log.getLogger ("test.mdeTest");
}

void main() {
    logger.info ("All unittests complete.");
}
